// ignore_for_file: non_constant_identifier_names

class ContactConsentModel {
  final String ContactId;
  final String ConsentMessageId;
  final String ConsentType;
  final bool ShowConsentBar;
  final bool NeedConsentReview;
  final bool? AllowTermsAndConditions;
  final bool? AllowPrivacyOverview;
  final bool? AllowNecessaryCookies;
  final bool? AllowPreferencesCookies;
  final bool? AllowAnalyticsCookies;
  final bool? AllowMarketingCookies;
  final bool? AllowSocialMediaCookies;
  final bool? AllowEmail;
  final bool? AllowSMS;
  final bool? AllowLine;
  final bool? AllowFacebook;
  final bool? AllowMobileNotification;

  ContactConsentModel({
    required this.ContactId,
    required this.ConsentMessageId,
    required this.ConsentType,
    required this.ShowConsentBar,
    required this.NeedConsentReview,
    required this.AllowTermsAndConditions,
    required this.AllowPrivacyOverview,
    required this.AllowNecessaryCookies,
    required this.AllowPreferencesCookies,
    required this.AllowAnalyticsCookies,
    required this.AllowMarketingCookies,
    required this.AllowSocialMediaCookies,
    required this.AllowEmail,
    required this.AllowSMS,
    required this.AllowLine,
    required this.AllowFacebook,
    required this.AllowMobileNotification,
  });

  factory ContactConsentModel.fromJson(Map<String, dynamic>? rawJson) {
    return ContactConsentModel(
      ContactId: rawJson?["contact_id"],
      ConsentMessageId: rawJson?["consent_message_id"],
      ConsentType: rawJson?["consent_type"],
      ShowConsentBar: rawJson?["show_consent_bar"],
      NeedConsentReview: rawJson?["need_consent_review"],
      AllowTermsAndConditions: rawJson?["allow_terms_and_conditions"] ?? false,
      AllowPrivacyOverview: rawJson?["allow_privacy_overview"] ?? false,
      AllowNecessaryCookies: rawJson?["allow_necessary_cookies"] ?? false,
      AllowPreferencesCookies: rawJson?["allow_preferences_cookies"] ?? false,
      AllowAnalyticsCookies: rawJson?["allow_analytics_cookies"] ?? false,
      AllowMarketingCookies: rawJson?["allow_marketing_cookies"] ?? false,
      AllowSocialMediaCookies: rawJson?["allow_social_media_cookies"] ?? false,
      AllowEmail: rawJson?["allow_email"] ?? false,
      AllowSMS: rawJson?["allow_sms"] ?? false,
      AllowLine: rawJson?["allow_line"] ?? false,
      AllowFacebook: rawJson?["allow_facebook"] ?? false,
      AllowMobileNotification: rawJson?["allow_mobile_notification"] ?? false,
    );
  }

  static List<ContactConsentModel> toList(
      List<Map<String, dynamic>>? rawItems) {
    if (rawItems == null) {
      return [];
    }

    List<ContactConsentModel> items = [];
    for (int i = 0; i < rawItems.length; i++) {
      items.add(ContactConsentModel.fromJson(rawItems[i]));
    }

    return items;
  }
}
